searchData={"items":[{"type":"module","title":"PuppeteerPdf","doc":"Wrapper library for NodeJS binary puppeteer-pdf.","ref":"PuppeteerPdf.html"},{"type":"function","title":"PuppeteerPdf.get_exec_version/0","doc":"Get puppeteer-pdf binary version","ref":"PuppeteerPdf.html#get_exec_version/0"},{"type":"function","title":"PuppeteerPdf.is_pdf/1","doc":"Verify if the file generated is a valid PDF file","ref":"PuppeteerPdf.html#is_pdf/1"},{"type":"module","title":"PuppeteerPdf.Generate","doc":"Generate a PDF file from multiple available sources.","ref":"PuppeteerPdf.Generate.html"},{"type":"function","title":"PuppeteerPdf.Generate.from_file/3","doc":"Generate PDF file with an HTML file path given as input.","ref":"PuppeteerPdf.Generate.html#from_file/3"},{"type":"function","title":"Options - PuppeteerPdf.Generate.from_file/3","doc":"- `header_template` - HTML template for the print header.\n- `footer_template` - HTML template for the print footer.\n- `display_header_footer` - Display header and footer.\n- `format` - Page format. Possible values: Letter, Legal, Tabloid, Ledger, A0, A1, A2, A3, A4, A5, A6\n- `margin_left` - Integer value (px)\n- `margin_right` - Integer value (px)\n- `margin_top` - Integer value (px)\n- `margin_bottom` - Integer value (px)\n- `scale` - Scale of the webpage rendering. (default: 1). Accept values between 0.1 and 2.\n- `width` - Paper width, accepts values labeled with units.\n- `height` - Paper height, accepts values labeled with units.\n- `debug` - Output Puppeteer PDF options\n- `landscape` - Paper orientation.\n- `print_background` - Print background graphics.\n- `timeout` - Integer value (ms), configures the timeout of the PDF creation (defaults to 5000)","ref":"PuppeteerPdf.Generate.html#from_file/3-options"},{"type":"function","title":"PuppeteerPdf.Generate.from_string/3","doc":"Generate PDF file given an HTML string input","ref":"PuppeteerPdf.Generate.html#from_string/3"},{"type":"function","title":"Options - PuppeteerPdf.Generate.from_string/3","doc":"- `header_template` - HTML template for the print header.\n- `footer_template` - HTML template for the print footer.\n- `display_header_footer` - Display header and footer.\n- `format` - Page format. Possible values: Letter, Legal, Tabloid, Ledger, A0, A1, A2, A3, A4, A5, A6\n- `margin_left` - Integer value (px)\n- `margin_right` - Integer value (px)\n- `margin_top` - Integer value (px)\n- `margin_bottom` - Integer value (px)\n- `scale` - Scale of the webpage rendering. (default: 1). Accept values between 0.1 and 2.\n- `width` - Paper width, accepts values labeled with units.\n- `height` - Paper height, accepts values labeled with units.\n- `debug` - Output Puppeteer PDF options\n- `landscape` - Paper orientation.\n- `print_background` - Print background graphics.\n- `timeout` - Integer value (ms), configures the timeout of the PDF creation (defaults to 5000)","ref":"PuppeteerPdf.Generate.html#from_string/3-options"},{"type":"function","title":"PuppeteerPdf.Generate.from_url/3","doc":"Generate PDF file with a URL given as input.","ref":"PuppeteerPdf.Generate.html#from_url/3"},{"type":"function","title":"Options - PuppeteerPdf.Generate.from_url/3","doc":"- `header_template` - HTML template for the print header.\n- `footer_template` - HTML template for the print footer.\n- `display_header_footer` - Display header and footer.\n- `format` - Page format. Possible values: Letter, Legal, Tabloid, Ledger, A0, A1, A2, A3, A4, A5, A6\n- `margin_left` - Integer value (px)\n- `margin_right` - Integer value (px)\n- `margin_top` - Integer value (px)\n- `margin_bottom` - Integer value (px)\n- `scale` - Scale of the webpage rendering. (default: 1). Accept values between 0.1 and 2.\n- `width` - Paper width, accepts values labeled with units.\n- `height` - Paper height, accepts values labeled with units.\n- `debug` - Output Puppeteer PDF options\n- `landscape` - Paper orientation.\n- `print_background` - Print background graphics.\n- `timeout` - Integer value (ms), configures the timeout of the PDF creation (defaults to 5000)","ref":"PuppeteerPdf.Generate.html#from_url/3-options"},{"type":"extras","title":"PuppeteerPdf","doc":"# PuppeteerPdf\n\n> This is a fork of https://github.com/coletiv/puppeteer-pdf\n\nThis is a wrapper to NodeJS module [puppeteer_pdf](https://www.npmjs.com/package/puppeteer-pdf). After some attempts to use wkhtmltopdf using [pdf_generator](https://github.com/gutschilla/elixir-pdf-generator), I've decided to use other software to generate PDF and create a wrapper for it.","ref":"readme.html"},{"type":"extras","title":"Puppeteer PDF vs wkhtmltopdf - PuppeteerPdf","doc":"","ref":"readme.html#puppeteer-pdf-vs-wkhtmltopdf"},{"type":"extras","title":"Disadvantage - PuppeteerPdf","doc":"* Bigger PDF file size.\n* NodeJS 8+ needed","ref":"readme.html#disadvantage"},{"type":"extras","title":"Advantages - PuppeteerPdf","doc":"* Display independent render (for better testing how template will be).","ref":"readme.html#advantages"},{"type":"extras","title":"Installation - PuppeteerPdf","doc":"Install `puppeteer-pdf` via npm, with the following command:\n\n```\nnpm i puppeteer-pdf -g\n```\n\nIf for some reason it doesn't download automatically chromium, it will give you the following error:\n\n```\n(node:14878) UnhandledPromiseRejectionWarning: Error: Chromium revision is not downloaded. Run \"npm install\" or \"yarn install\"\nat Launcher.launch (/usr/local/lib/node_modules/puppeteer-pdf/node_modules/puppeteer/lib/Launcher.js:119:15)\nat  \n(node:14878) UnhandledPromiseRejectionWarning: Unhandled promise rejection. This error originated either by throwing inside of an async function without a catch block, or by rejecting a promise which was not handled with .catch(). (rejection id: 1)\n(node:14878) [DEP0018] DeprecationWarning: Unhandled promise rejections are deprecated. In the future, promise rejections that are not handled will terminate the Node.js process with a non-zero exit code.\n```\n\nTo solve this, you execute the following commands to copy chromium from the `puppeteer` folder, to the `puppeteer` inside the `puppeteer-pdf`.\n\nOn OSX and Linux systems should be the following commands:\n\n```\nnpm -i puppeteer -g # This should install chromium\ncp -R /usr/local/lib/node_modules/puppeteer/.local-chromium/ /usr/local/lib/node_modules/puppeteer-pdf/node_modules/puppeteer/\n```\n\nIf you have issues related to this, please comment on [this issue](https://github.com/coletiv/puppeteer-pdf/issues/13).\n\nOn your elixir project, you just need to add the following dependency:\n\n```elixir\ndef deps do\n  [\n    {:puppeteer_pdf, \"~> 1.0.1\"}\n  ]\nend\n```\n\nIf you have the older `applications` structure inside `mix.exs`, you need to add `:briefly` to it. If you have `extra_applications`, you don't need to do anything.","ref":"readme.html#installation"},{"type":"extras","title":"How to use - PuppeteerPdf","doc":"","ref":"readme.html#how-to-use"},{"type":"extras","title":"Initial - PuppeteerPdf","doc":"These are the options available right now:\n\n```elixir\noptions = [\n  margin_left: 40,\n  margin_right: 40,\n  margin_top: 40,\n  margin_bottom: 150,\n  format: \"A4\",\n  print_background: true,\n  header_template: header_html, # Support both file and html\n  footer_template: footer_html,\n  display_header_footer: true,\n  debug: true,\n  timeout: 10000 # value passed directly to Task.await/2. (Defaults to 5000)\n]\n```\n\nAnd to generate the PDF you can use the following code using Phoenix Template:\n\n```\n# Get template rendered previously\nhtml = Phoenix.View.render_to_string(\n  MyApp.View,\n  \"pdf/invoice.html\",\n  assigns\n)\n\n# Get full path to generated pdf file\npdf_path = Path.absname(\"invoice.pdf\")\n\ncase PuppeteerPdf.Generate.from_string(html, pdf_path, options) do\n  {:ok, _} -> ...\n  {:error, message} -> ...\nend\n```\n\nOr just with HTML file:\n\n```\nhtml_path = Path.absname(\"random.html\")\ncase PuppeteerPdf.Generate.from_file(html_path, pdf_path, options) do\n  {:ok, _} -> ...\n  {:error, message} -> ...\nend\n```","ref":"readme.html#initial"},{"type":"extras","title":"Using header and footer templates - PuppeteerPdf","doc":"You can defined an HTML header and footer, using the `header_template` and `footer_template` options.\nTo use a file, use the following format: `file:///home/user/file.html`.\n\nDon't forget to also include `display_header_footer` to `true`.","ref":"readme.html#using-header-and-footer-templates"},{"type":"extras","title":"Configure execution path - PuppeteerPdf","doc":"In order to configure this setting:\n\n```elixir\nconfig :puppeteer_pdf, exec_path: \"/usr/local/bin/puppeteer-pdf\"\n```\n\nOr you can use system environment variable:\n\n```\nexport PUPPETEER_PDF_PATH=/usr/local/bin/puppeteer-pdf\n```\n\nFor development purposes when working on this project, you can set the `PUPPETEER_PDF_PATH`\nenvironment variable to point to the `puppeteer-pdf` executable. **Do not attempt to use this env\nvar to set the path in production. Instead, use the application configuration, above.**","ref":"readme.html#configure-execution-path"},{"type":"extras","title":"Continuous Integration - PuppeteerPdf","doc":"If you use CI\n\n```\nbefore_script:\n- nvm install 8\n- npm i puppeteer-pdf -g\n```","ref":"readme.html#continuous-integration"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}